Index: code/branches/core6/src/libraries/core/BaseObject.cc
===================================================================
--- code/branches/core6/src/libraries/core/BaseObject.cc	(revision 9658)
+++ code/branches/core6/src/libraries/core/BaseObject.cc	(revision 9659)
@@ -57,5 +57,5 @@
     BaseObject::BaseObject(Context* context) : bInitialized_(false)
     {
-        RegisterRootObject(BaseObject);
+        RegisterObject(BaseObject);
 
         this->bInitialized_ = true;
Index: code/branches/core6/src/libraries/core/Core.cc
===================================================================
--- code/branches/core6/src/libraries/core/Core.cc	(revision 9658)
+++ code/branches/core6/src/libraries/core/Core.cc	(revision 9659)
@@ -179,5 +179,5 @@
         // Do this soon after the ConfigFileManager has been created to open up the
         // possibility to configure everything below here
-        RegisterRootObject(Core);
+        RegisterObject(Core);
         orxout(internal_info) << "configuring Core" << endl;
         this->setConfigValues();
@@ -516,5 +516,5 @@
     DevModeListener::DevModeListener()
     {
-        RegisterRootObject(DevModeListener);
+        RegisterObject(DevModeListener);
     }
 }
Index: code/branches/core6/src/libraries/core/CoreIncludes.h
===================================================================
--- code/branches/core6/src/libraries/core/CoreIncludes.h	(revision 9658)
+++ code/branches/core6/src/libraries/core/CoreIncludes.h	(revision 9659)
@@ -37,10 +37,13 @@
     @brief Defines several very important macros used to register objects, register classes, and to work with identifiers.
 
-    Every class needs the @c RegisterObject(class) macro in its constructor. If the class is an interface
-    or the @c BaseObject itself, it needs the macro @c RegisterRootObject(class) instead.
+    Every class needs the @c RegisterObject(class) macro in its constructor.
 
     To register @a class in the class-hierarchy, use the @c RegisterClass(class) macro outside of the class implementation,
     so it gets executed statically before @c main(). If you don't want @a class to be loadable, but still register it, call
     @c RegisterUnloadableClass(class).
+
+    Abstract classes are registered with @c RegisterAbstractClass(class). For abstract classes, the inheritance must be
+    defined manually with @c RegisterAbstractClass(class).inheritsFrom(Class(parent)). Multiple parent classes can be defined
+    by chaining the above command.
 
     Example:
@@ -125,30 +128,12 @@
 
 /**
-    @brief Intern macro, containing the common parts of @c RegisterObject and @c RegisterRootObject.
-    @param ClassName The name of the class
-    @param bRootClass True if the class is directly derived from orxonox::OrxonoxClass
-*/
-#define InternRegisterObject(ClassName) \
+    @brief Registers a newly created object in the framework. Has to be called at the beginning of the constructor of @a ClassName.
+    @param ClassName The name of the class
+*/
+#define RegisterObject(ClassName) \
     if (ClassIdentifier<ClassName>::getIdentifier(#ClassName)->initializeObject(this)) \
         return; \
     else \
         ((void)0)
-
-/**
-    @brief Registers a newly created object in the framework. Has to be called at the beginning of the constructor of @a ClassName.
-    @param ClassName The name of the class
-*/
-#define RegisterObject(ClassName) \
-    InternRegisterObject(ClassName)
-
-/**
-    @brief Registers a newly created object in the framework. Has to be called at the beginning of the constructor of @a ClassName.
-    @param ClassName The name of the class
-
-    In contrast to RegisterObject, this is used for classes that inherit directly from
-    orxonox::OrxonoxClass, namely all interfaces and orxonox::BaseObject.
-*/
-#define RegisterRootObject(ClassName) \
-    InternRegisterObject(ClassName)
 
 /**
Index: code/branches/core6/src/libraries/core/GUIManager.cc
===================================================================
--- code/branches/core6/src/libraries/core/GUIManager.cc	(revision 9658)
+++ code/branches/core6/src/libraries/core/GUIManager.cc	(revision 9659)
@@ -256,5 +256,5 @@
         , destructionHelper_(this)
     {
-        RegisterRootObject(GUIManager);
+        RegisterObject(GUIManager);
 
         orxout(internal_status) << "initializing GUIManager..." << endl;
Index: code/branches/core6/src/libraries/core/Game.cc
===================================================================
--- code/branches/core6/src/libraries/core/Game.cc	(revision 9658)
+++ code/branches/core6/src/libraries/core/Game.cc	(revision 9659)
@@ -112,5 +112,5 @@
 
         // Do this after the Core creation!
-        RegisterRootObject(Game);
+        RegisterObject(Game);
         this->setConfigValues();
 
Index: code/branches/core6/src/libraries/core/ViewportEventListener.cc
===================================================================
--- code/branches/core6/src/libraries/core/ViewportEventListener.cc	(revision 9658)
+++ code/branches/core6/src/libraries/core/ViewportEventListener.cc	(revision 9659)
@@ -36,5 +36,5 @@
     ViewportEventListener::ViewportEventListener()
     {
-        RegisterRootObject(ViewportEventListener);
+        RegisterObject(ViewportEventListener);
     }
 }
Index: code/branches/core6/src/libraries/core/WindowEventListener.cc
===================================================================
--- code/branches/core6/src/libraries/core/WindowEventListener.cc	(revision 9658)
+++ code/branches/core6/src/libraries/core/WindowEventListener.cc	(revision 9659)
@@ -39,5 +39,5 @@
     WindowEventListener::WindowEventListener()
     {
-        RegisterRootObject(WindowEventListener);
+        RegisterObject(WindowEventListener);
     }
 
Index: code/branches/core6/src/libraries/core/XMLNameListener.cc
===================================================================
--- code/branches/core6/src/libraries/core/XMLNameListener.cc	(revision 9658)
+++ code/branches/core6/src/libraries/core/XMLNameListener.cc	(revision 9659)
@@ -36,5 +36,5 @@
     XMLNameListener::XMLNameListener()
     {
-        RegisterRootObject(XMLNameListener);
+        RegisterObject(XMLNameListener);
     }
 }
Index: code/branches/core6/src/libraries/core/command/Shell.cc
===================================================================
--- code/branches/core6/src/libraries/core/command/Shell.cc	(revision 9658)
+++ code/branches/core6/src/libraries/core/command/Shell.cc	(revision 9659)
@@ -68,5 +68,5 @@
         , bScrollable_(bScrollable)
     {
-        RegisterRootObject(Shell);
+        RegisterObject(Shell);
 
         OutputManager::getInstance().registerListener(this);
Index: code/branches/core6/src/libraries/core/input/InputBuffer.cc
===================================================================
--- code/branches/core6/src/libraries/core/input/InputBuffer.cc	(revision 9658)
+++ code/branches/core6/src/libraries/core/input/InputBuffer.cc	(revision 9659)
@@ -39,5 +39,5 @@
     InputBuffer::InputBuffer()
     {
-        RegisterRootObject(InputBuffer);
+        RegisterObject(InputBuffer);
 
         this->cursor_ = 0;
@@ -59,5 +59,5 @@
     InputBuffer::InputBuffer(const std::string& allowedChars)
     {
-        RegisterRootObject(InputBuffer);
+        RegisterObject(InputBuffer);
 
         this->maxLength_ = 1024;
Index: code/branches/core6/src/libraries/core/input/InputManager.cc
===================================================================
--- code/branches/core6/src/libraries/core/input/InputManager.cc	(revision 9658)
+++ code/branches/core6/src/libraries/core/input/InputManager.cc	(revision 9659)
@@ -98,5 +98,5 @@
         , calibratorCallbackHandler_(0)
     {
-        RegisterRootObject(InputManager);
+        RegisterObject(InputManager);
 
         orxout(internal_status, context::input) << "InputManager: Constructing..." << endl;
Index: code/branches/core6/src/libraries/core/input/JoyStick.cc
===================================================================
--- code/branches/core6/src/libraries/core/input/JoyStick.cc	(revision 9658)
+++ code/branches/core6/src/libraries/core/input/JoyStick.cc	(revision 9659)
@@ -51,5 +51,5 @@
         : super(id, oisInputManager)
     {
-        RegisterRootObject(JoyStick);
+        RegisterObject(JoyStick);
         this->setConfigValues();
         // Initialise POV and Slider states
Index: code/branches/core6/src/libraries/core/input/KeyBinder.cc
===================================================================
--- code/branches/core6/src/libraries/core/input/KeyBinder.cc	(revision 9658)
+++ code/branches/core6/src/libraries/core/input/KeyBinder.cc	(revision 9659)
@@ -58,5 +58,5 @@
         mousePosition_[1] = 0.0;
 
-        RegisterRootObject(KeyBinder);
+        RegisterObject(KeyBinder);
 
         // initialise all buttons and half axes to avoid creating everything with 'new'
Index: code/branches/core6/src/libraries/core/input/Mouse.cc
===================================================================
--- code/branches/core6/src/libraries/core/input/Mouse.cc	(revision 9658)
+++ code/branches/core6/src/libraries/core/input/Mouse.cc	(revision 9659)
@@ -54,5 +54,5 @@
         : super(id, oisInputManager)
     {
-        RegisterRootObject(Mouse);
+        RegisterObject(Mouse);
         this->windowResized(this->getWindowWidth(), this->getWindowHeight());
 
Index: code/branches/core6/src/libraries/network/ClientConnectionListener.cc
===================================================================
--- code/branches/core6/src/libraries/network/ClientConnectionListener.cc	(revision 9658)
+++ code/branches/core6/src/libraries/network/ClientConnectionListener.cc	(revision 9659)
@@ -39,5 +39,5 @@
     ClientConnectionListener::ClientConnectionListener()
     {
-        RegisterRootObject(ClientConnectionListener);
+        RegisterObject(ClientConnectionListener);
     }
 
Index: code/branches/core6/src/libraries/network/Host.cc
===================================================================
--- code/branches/core6/src/libraries/network/Host.cc	(revision 9658)
+++ code/branches/core6/src/libraries/network/Host.cc	(revision 9659)
@@ -145,5 +145,5 @@
   NetworkChatListener::NetworkChatListener()
   {
-      RegisterRootObject(NetworkChatListener);
+      RegisterObject(NetworkChatListener);
   }
 
Index: code/branches/core6/src/libraries/network/NetworkFunction.cc
===================================================================
--- code/branches/core6/src/libraries/network/NetworkFunction.cc	(revision 9658)
+++ code/branches/core6/src/libraries/network/NetworkFunction.cc	(revision 9659)
@@ -44,5 +44,5 @@
   NetworkFunctionBase::NetworkFunctionBase(const std::string& name)
   {
-    RegisterRootObject(NetworkFunctionBase);
+      RegisterObject(NetworkFunctionBase);
 
     static uint32_t networkID = 0;
Index: code/branches/core6/src/libraries/network/synchronisable/Synchronisable.cc
===================================================================
--- code/branches/core6/src/libraries/network/synchronisable/Synchronisable.cc	(revision 9658)
+++ code/branches/core6/src/libraries/network/synchronisable/Synchronisable.cc	(revision 9659)
@@ -53,5 +53,5 @@
   Synchronisable::Synchronisable(Context* context)
   {
-    RegisterRootObject(Synchronisable);
+      RegisterObject(Synchronisable);
     static uint32_t idCounter=0;
     objectMode_=0x1; // by default do not send data to server
Index: code/branches/core6/src/libraries/tools/Timer.cc
===================================================================
--- code/branches/core6/src/libraries/tools/Timer.cc	(revision 9658)
+++ code/branches/core6/src/libraries/tools/Timer.cc	(revision 9659)
@@ -140,5 +140,5 @@
     {
         this->init();
-        RegisterRootObject(Timer);
+        RegisterObject(Timer);
     }
 
@@ -153,5 +153,5 @@
     {
         this->init();
-        RegisterRootObject(Timer);
+        RegisterObject(Timer);
 
         this->setTimer(interval, bLoop, executor, bKillAfterCall);
Index: code/branches/core6/src/libraries/tools/interfaces/ToolsInterfaceCompilation.cc
===================================================================
--- code/branches/core6/src/libraries/tools/interfaces/ToolsInterfaceCompilation.cc	(revision 9658)
+++ code/branches/core6/src/libraries/tools/interfaces/ToolsInterfaceCompilation.cc	(revision 9659)
@@ -50,5 +50,5 @@
     TimeFactorListener::TimeFactorListener()
     {
-        RegisterRootObject(TimeFactorListener);
+        RegisterObject(TimeFactorListener);
     }
 
@@ -74,5 +74,5 @@
     Tickable::Tickable()
     {
-        RegisterRootObject(Tickable);
+        RegisterObject(Tickable);
     }
 }
Index: code/branches/core6/src/modules/designtools/ScreenshotManager.cc
===================================================================
--- code/branches/core6/src/modules/designtools/ScreenshotManager.cc	(revision 9658)
+++ code/branches/core6/src/modules/designtools/ScreenshotManager.cc	(revision 9659)
@@ -69,5 +69,5 @@
     ScreenshotManager::ScreenshotManager() : finalPicturePB_(NULL), data_(NULL)
     {
-        RegisterRootObject(ScreenshotManager);
+        RegisterObject(ScreenshotManager);
         
         this->setConfigValues();
Index: code/branches/core6/src/modules/designtools/SkyboxGenerator.cc
===================================================================
--- code/branches/core6/src/modules/designtools/SkyboxGenerator.cc	(revision 9658)
+++ code/branches/core6/src/modules/designtools/SkyboxGenerator.cc	(revision 9659)
@@ -68,5 +68,5 @@
     SkyboxGenerator::SkyboxGenerator()
     {
-        RegisterRootObject(SkyboxGenerator);
+        RegisterObject(SkyboxGenerator);
 
         this->setConfigValues();
Index: code/branches/core6/src/modules/notifications/NotificationManager.cc
===================================================================
--- code/branches/core6/src/modules/notifications/NotificationManager.cc	(revision 9658)
+++ code/branches/core6/src/modules/notifications/NotificationManager.cc	(revision 9659)
@@ -55,5 +55,5 @@
     NotificationManager::NotificationManager()
     {
-        RegisterRootObject(NotificationManager);
+        RegisterObject(NotificationManager);
 
         orxout(internal_info, context::notifications) << "NotificatioManager created." << endl;
Index: code/branches/core6/src/modules/weapons/projectiles/BasicProjectile.cc
===================================================================
--- code/branches/core6/src/modules/weapons/projectiles/BasicProjectile.cc	(revision 9658)
+++ code/branches/core6/src/modules/weapons/projectiles/BasicProjectile.cc	(revision 9659)
@@ -50,5 +50,5 @@
     BasicProjectile::BasicProjectile()
     {
-        RegisterRootObject(BasicProjectile);// Register the BasicProjectile class to the core
+        RegisterObject(BasicProjectile);// Register the BasicProjectile class to the core
 
         this->bDestroy_ = false;
Index: code/branches/core6/src/orxonox/LevelManager.cc
===================================================================
--- code/branches/core6/src/orxonox/LevelManager.cc	(revision 9658)
+++ code/branches/core6/src/orxonox/LevelManager.cc	(revision 9659)
@@ -59,5 +59,5 @@
     LevelManager::LevelManager()
     {
-        RegisterRootObject(LevelManager);
+        RegisterObject(LevelManager);
         this->setConfigValues();
 
Index: code/branches/core6/src/orxonox/MoodManager.cc
===================================================================
--- code/branches/core6/src/orxonox/MoodManager.cc	(revision 9658)
+++ code/branches/core6/src/orxonox/MoodManager.cc	(revision 9659)
@@ -43,5 +43,5 @@
     MoodManager::MoodManager()
     {
-        RegisterRootObject(MoodManager);
+        RegisterObject(MoodManager);
         this->setConfigValues();
 
@@ -95,5 +95,5 @@
     MoodListener::MoodListener()
     {
-        RegisterRootObject(MoodListener);
+        RegisterObject(MoodListener);
     }
 
Index: code/branches/core6/src/orxonox/PawnManager.cc
===================================================================
--- code/branches/core6/src/orxonox/PawnManager.cc	(revision 9658)
+++ code/branches/core6/src/orxonox/PawnManager.cc	(revision 9659)
@@ -39,5 +39,5 @@
     PawnManager::PawnManager()
     {
-        RegisterRootObject(PawnManager);
+        RegisterObject(PawnManager);
     }
 
Index: code/branches/core6/src/orxonox/PlayerManager.cc
===================================================================
--- code/branches/core6/src/orxonox/PlayerManager.cc	(revision 9658)
+++ code/branches/core6/src/orxonox/PlayerManager.cc	(revision 9659)
@@ -43,5 +43,5 @@
     PlayerManager::PlayerManager()
     {
-        RegisterRootObject(PlayerManager);
+        RegisterObject(PlayerManager);
 
 //         this->getConnectedClients();
Index: code/branches/core6/src/orxonox/chat/ChatManager.cc
===================================================================
--- code/branches/core6/src/orxonox/chat/ChatManager.cc	(revision 9658)
+++ code/branches/core6/src/orxonox/chat/ChatManager.cc	(revision 9659)
@@ -117,5 +117,5 @@
     ChatListener::ChatListener()
     {
-        RegisterRootObject(ChatListener);
+        RegisterObject(ChatListener);
     }
 }
Index: code/branches/core6/src/orxonox/gamestates/GSMainMenu.cc
===================================================================
--- code/branches/core6/src/orxonox/gamestates/GSMainMenu.cc	(revision 9658)
+++ code/branches/core6/src/orxonox/gamestates/GSMainMenu.cc	(revision 9659)
@@ -66,5 +66,5 @@
         : GameState(info)
     {
-        RegisterRootObject(GSMainMenu);
+        RegisterObject(GSMainMenu);
 
         InputManager::getInstance().createInputState("MainMenuHackery", true, true)->setKeyHandler(KeyBinderManager::getInstance().getDefaultAsHandler());
Index: code/branches/core6/src/orxonox/interfaces/InterfaceCompilation.cc
===================================================================
--- code/branches/core6/src/orxonox/interfaces/InterfaceCompilation.cc	(revision 9658)
+++ code/branches/core6/src/orxonox/interfaces/InterfaceCompilation.cc	(revision 9659)
@@ -54,5 +54,5 @@
     GametypeMessageListener::GametypeMessageListener()
     {
-        RegisterRootObject(GametypeMessageListener);
+        RegisterObject(GametypeMessageListener);
     }
 
@@ -64,5 +64,5 @@
     PlayerTrigger::PlayerTrigger()
     {
-        RegisterRootObject(PlayerTrigger);
+        RegisterObject(PlayerTrigger);
 
         this->isForPlayer_ = false;
@@ -84,5 +84,5 @@
     RadarListener::RadarListener()
     {
-        RegisterRootObject(RadarListener);
+        RegisterObject(RadarListener);
     }
 
@@ -94,5 +94,5 @@
     TeamColourable::TeamColourable()
     {
-        RegisterRootObject(TeamColourable);
+        RegisterObject(TeamColourable);
     }
 
@@ -104,5 +104,5 @@
     Rewardable::Rewardable()
     {
-        RegisterRootObject(Rewardable);
+        RegisterObject(Rewardable);
     }
 }
Index: code/branches/core6/src/orxonox/interfaces/NotificationListener.cc
===================================================================
--- code/branches/core6/src/orxonox/interfaces/NotificationListener.cc	(revision 9658)
+++ code/branches/core6/src/orxonox/interfaces/NotificationListener.cc	(revision 9659)
@@ -53,5 +53,5 @@
     NotificationListener::NotificationListener()
     {
-        RegisterRootObject(NotificationListener);
+        RegisterObject(NotificationListener);
     }
 
Index: code/branches/core6/src/orxonox/interfaces/PickupCarrier.cc
===================================================================
--- code/branches/core6/src/orxonox/interfaces/PickupCarrier.cc	(revision 9658)
+++ code/branches/core6/src/orxonox/interfaces/PickupCarrier.cc	(revision 9659)
@@ -49,5 +49,5 @@
     PickupCarrier::PickupCarrier()
     {
-        RegisterRootObject(PickupCarrier);
+        RegisterObject(PickupCarrier);
     }
 
Index: code/branches/core6/src/orxonox/interfaces/PickupListener.cc
===================================================================
--- code/branches/core6/src/orxonox/interfaces/PickupListener.cc	(revision 9658)
+++ code/branches/core6/src/orxonox/interfaces/PickupListener.cc	(revision 9659)
@@ -47,5 +47,5 @@
     PickupListener::PickupListener()
     {
-        RegisterRootObject(PickupListener);
+        RegisterObject(PickupListener);
     }
 
Index: code/branches/core6/src/orxonox/interfaces/Pickupable.cc
===================================================================
--- code/branches/core6/src/orxonox/interfaces/Pickupable.cc	(revision 9658)
+++ code/branches/core6/src/orxonox/interfaces/Pickupable.cc	(revision 9659)
@@ -54,5 +54,5 @@
     Pickupable::Pickupable() : used_(false), pickedUp_(false)
     {
-        RegisterRootObject(Pickupable);
+        RegisterObject(Pickupable);
 
         this->carrier_ = NULL;
Index: code/branches/core6/src/orxonox/interfaces/RadarViewable.cc
===================================================================
--- code/branches/core6/src/orxonox/interfaces/RadarViewable.cc	(revision 9658)
+++ code/branches/core6/src/orxonox/interfaces/RadarViewable.cc	(revision 9659)
@@ -53,5 +53,5 @@
         , scale_(1.0f)
     {
-        RegisterRootObject(RadarViewable);
+        RegisterObject(RadarViewable);
 
         this->uniqueId_=getUniqueNumberString();
Index: code/branches/core6/src/orxonox/sound/BaseSound.cc
===================================================================
--- code/branches/core6/src/orxonox/sound/BaseSound.cc	(revision 9658)
+++ code/branches/core6/src/orxonox/sound/BaseSound.cc	(revision 9659)
@@ -52,5 +52,5 @@
         , pitch_ (1.0)
     {
-        RegisterRootObject(BaseSound);
+        RegisterObject(BaseSound);
 
         // Initialise audioSource_ to a value that is not a source
Index: code/branches/core6/src/orxonox/sound/SoundManager.cc
===================================================================
--- code/branches/core6/src/orxonox/sound/SoundManager.cc	(revision 9658)
+++ code/branches/core6/src/orxonox/sound/SoundManager.cc	(revision 9659)
@@ -69,5 +69,5 @@
         : effectsPoolSize_(0)
     {
-        RegisterRootObject(SoundManager);
+        RegisterObject(SoundManager);
 
         orxout(user_status) << "Loading sound" << endl;
Index: code/branches/core6/test/core/class/IdentifiableTest.cc
===================================================================
--- code/branches/core6/test/core/class/IdentifiableTest.cc	(revision 9658)
+++ code/branches/core6/test/core/class/IdentifiableTest.cc	(revision 9659)
@@ -10,5 +10,5 @@
         {
             public:
-                IdentifiableTest() { RegisterRootObject(IdentifiableTest); }
+                IdentifiableTest() { RegisterObject(IdentifiableTest); }
         };
     }
Index: code/branches/core6/test/core/class/IdentifierClassHierarchyTest.cc
===================================================================
--- code/branches/core6/test/core/class/IdentifierClassHierarchyTest.cc	(revision 9658)
+++ code/branches/core6/test/core/class/IdentifierClassHierarchyTest.cc	(revision 9659)
@@ -24,5 +24,5 @@
                 BaseInterface1()
                 {
-                    RegisterRootObject(BaseInterface1);
+                    RegisterObject(BaseInterface1);
                 }
 
@@ -35,5 +35,5 @@
                 BaseInterface2()
                 {
-                    RegisterRootObject(BaseInterface2);
+                    RegisterObject(BaseInterface2);
                 }
 
@@ -64,5 +64,5 @@
                 BaseClass()
                 {
-                    RegisterRootObject(BaseClass);
+                    RegisterObject(BaseClass);
                 }
         };
Index: code/branches/core6/test/core/class/IdentifierExternalClassHierarchyTest.cc
===================================================================
--- code/branches/core6/test/core/class/IdentifierExternalClassHierarchyTest.cc	(revision 9658)
+++ code/branches/core6/test/core/class/IdentifierExternalClassHierarchyTest.cc	(revision 9659)
@@ -12,5 +12,5 @@
                 Interface()
                 {
-                    RegisterRootObject(Interface);
+                    RegisterObject(Interface);
                 }
 
@@ -23,5 +23,5 @@
                 BaseClass()
                 {
-                    RegisterRootObject(BaseClass);
+                    RegisterObject(BaseClass);
                 }
         };
Index: code/branches/core6/test/core/class/IdentifierSimpleClassHierarchyTest.cc
===================================================================
--- code/branches/core6/test/core/class/IdentifierSimpleClassHierarchyTest.cc	(revision 9658)
+++ code/branches/core6/test/core/class/IdentifierSimpleClassHierarchyTest.cc	(revision 9659)
@@ -14,5 +14,5 @@
                 Interface()
                 {
-                    RegisterRootObject(Interface);
+                    RegisterObject(Interface);
                 }
 
@@ -25,5 +25,5 @@
                 BaseClass()
                 {
-                    RegisterRootObject(BaseClass);
+                    RegisterObject(BaseClass);
                 }
         };
Index: code/branches/core6/test/core/class/IdentifierTest.cc
===================================================================
--- code/branches/core6/test/core/class/IdentifierTest.cc	(revision 9658)
+++ code/branches/core6/test/core/class/IdentifierTest.cc	(revision 9659)
@@ -10,5 +10,5 @@
         {
             public:
-                TestClass() { RegisterRootObject(TestClass); }
+                TestClass() { RegisterObject(TestClass); }
         };
 
Index: code/branches/core6/test/core/class/SubclassIdentifierTest.cc
===================================================================
--- code/branches/core6/test/core/class/SubclassIdentifierTest.cc	(revision 9658)
+++ code/branches/core6/test/core/class/SubclassIdentifierTest.cc	(revision 9659)
@@ -12,5 +12,5 @@
         {
             public:
-                TestClass(Context* context = NULL) { RegisterRootObject(TestClass); }
+                TestClass(Context* context = NULL) { RegisterObject(TestClass); }
         };
 
Index: code/branches/core6/test/core/class/SuperTest.cc
===================================================================
--- code/branches/core6/test/core/class/SuperTest.cc	(revision 9658)
+++ code/branches/core6/test/core/class/SuperTest.cc	(revision 9659)
@@ -15,5 +15,5 @@
                 TestClass(Context* context = NULL) : BaseObject(context), changedNameBase_(false), xmlPortBase_(false), modeBase_(XMLPort::NOP)
                 {
-                    RegisterRootObject(TestClass);
+                    RegisterObject(TestClass);
                 }
 
Index: code/branches/core6/test/core/object/ContextTest.cc
===================================================================
--- code/branches/core6/test/core/object/ContextTest.cc	(revision 9658)
+++ code/branches/core6/test/core/object/ContextTest.cc	(revision 9659)
@@ -11,5 +11,5 @@
         {
             public:
-                SubclassContext() : Context(NULL) { RegisterRootObject(SubclassContext); }
+                SubclassContext() : Context(NULL) { RegisterObject(SubclassContext); }
         };
 
Index: code/branches/core6/test/core/object/IteratorTest.cc
===================================================================
--- code/branches/core6/test/core/object/IteratorTest.cc	(revision 9658)
+++ code/branches/core6/test/core/object/IteratorTest.cc	(revision 9659)
@@ -14,5 +14,5 @@
         {
             public:
-            TestInterface() { RegisterRootObject(TestInterface); }
+            TestInterface() { RegisterObject(TestInterface); }
         };
 
@@ -20,5 +20,5 @@
         {
             public:
-                TestClass() { RegisterRootObject(TestClass); }
+                TestClass() { RegisterObject(TestClass); }
                 MOCK_METHOD0(test, void());
         };
Index: code/branches/core6/test/core/object/ListableTest.cc
===================================================================
--- code/branches/core6/test/core/object/ListableTest.cc	(revision 9658)
+++ code/branches/core6/test/core/object/ListableTest.cc	(revision 9659)
@@ -10,5 +10,5 @@
         {
             public:
-            ListableClassTest() { RegisterRootObject(ListableClassTest); }
+            ListableClassTest() { RegisterObject(ListableClassTest); }
         };
 
Index: code/branches/core6/test/core/object/ObjectListIteratorTest.cc
===================================================================
--- code/branches/core6/test/core/object/ObjectListIteratorTest.cc	(revision 9658)
+++ code/branches/core6/test/core/object/ObjectListIteratorTest.cc	(revision 9659)
@@ -13,5 +13,5 @@
         {
             public:
-                ListableTest() { RegisterRootObject(ListableTest); }
+                ListableTest() { RegisterObject(ListableTest); }
                 MOCK_METHOD0(test, void());
         };