Index: /trunk/src/lib/Makefile.am
===================================================================
--- /trunk/src/lib/Makefile.am	(revision 9661)
+++ /trunk/src/lib/Makefile.am	(revision 9662)
@@ -8,5 +8,5 @@
 		lang/class_list.cc \
 		lang/new_class_id.cc \
-		lang/new_class_list.cc \
+		lang/new_object_list.cc \
 		\
 		coord/p_node.cc \
@@ -18,5 +18,5 @@
 		lang/class_list.h \
 		lang/new_class_id.h \
-		lang/new_class_list.h \
+		lang/new_object_list.h \
 		\
 		coord/p_node.h \
Index: unk/src/lib/lang/new_class_list.cc
===================================================================
--- /trunk/src/lib/lang/new_class_list.cc	(revision 9661)
+++ 	(revision )
@@ -1,55 +1,0 @@
-/*
-   orxonox - the future of 3D-vertical-scrollers
-
-   Copyright (C) 2006 orx
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
-
-   ### File Specific:
-   main-programmer: Benjamin Grauer
-   co-programmer: ...
-*/
-
-//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
-
-#include "new_class_list.h"
-#include <cassert>
-
-
-NewObjectListBase::NewObjectListBase(const std::string& className)
-    : _id(-1), _name(className)
-{
-  if (NewObjectListBase::_classes == NULL)
-    NewObjectListBase::_classes = new cList;
-  assert(!NewObjectListBase::exists(className) && "Classes should not be included once, and no two classes should have the same name (key value)");
-
-
-
-}
-
-NewObjectListBase::~NewObjectListBase()
-{
-
-}
-
-int NewObjectListBase::_idCounter = 0;
-NewObjectListBase::cList* NewObjectListBase::_classes = NULL;
-
-
-
-/**
- * @brief Checks if a Class with name already exists.
- * @param name The Name of the Class to check.
- * @return true if such a class already exists.
- */
-bool NewObjectListBase::exists(const std::string& name)
-{
-  cList::iterator it;
-  for (it = NewObjectListBase::_classes->begin(); it != NewObjectListBase::_classes->end(); it++)
-    if(*it != NULL && (*it)->name() != name)
-      return true;
-  return false;
-}
Index: unk/src/lib/lang/new_class_list.h
===================================================================
--- /trunk/src/lib/lang/new_class_list.h	(revision 9661)
+++ 	(revision )
@@ -1,75 +1,0 @@
-/*!
- * @file new_class_list.h
- * @brief Definition of a dynamically allocating ClassID
- *
- */
-
-#ifndef _NEW_CLASS_LIST_H
-#define _NEW_CLASS_LIST_H
-
-#include "type_info.h"
-#include <set>
-#include <string>
-
-#define DeclareClass(ClassName) \
-   NewObjectList ClassID_##ClassName(ClassName)
-
-#define DeclareInClass(ClassName) \
-   NewObjectList classList(ClassName)
-
-class NewObjectListBase
-{
-public:
-  int id() const { return _id; };
-  const std::string& name() const { return _name; };
-
-  static int classCount() { return _idCounter; };
-
-  bool compareName(const NewObjectListBase& more) { return this->_name < more.name(); };
-  bool compareID(const NewObjectListBase& more) { return this->_id < more.id(); };
-
-protected:
-  NewObjectListBase(const std::string& className);
-  ~NewObjectListBase();
-private:
-  NewObjectListBase(const NewObjectListBase&);
-
-  static bool exists(const std::string& className);
-
-private:
-  int                           _id;
-  std::string                   _name;
-
-private:
-  typedef std::set<NewObjectListBase*>  cList;
-
-  static int                           _idCounter;      //!< A counter, that gives all classes a Unique ClassID. Access to this Variable is to be Thread-Safe.
-  static cList*                        _classes;        //!< A Set of all the classes in existance.
-};
-
-
-/////////////////////////
-//// TEMPLATISATION /////
-/////////////////////////
-template<class T> class NewObjectList : public NewObjectListBase
-{
-public:
-  NewObjectList(const std::string& name);
-  ~NewObjectList();
-
-private:
-  //! the copy constructor will be hidden.
-  NewObjectList(const NewObjectList& definer) {};
-};
-
-template <class T>
-NewObjectList<T>::NewObjectList(const std::string& name)
-    : NewObjectListBase(name)
-{}
-
-template <class T>
-NewObjectList<T>::~NewObjectList()
-{}
-
-
-#endif /* _NEW_CLASS_LIST_H */
Index: /trunk/src/lib/lang/new_object_list.cc
===================================================================
--- /trunk/src/lib/lang/new_object_list.cc	(revision 9662)
+++ /trunk/src/lib/lang/new_object_list.cc	(revision 9662)
@@ -0,0 +1,55 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2006 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
+
+#include "new_object_list.h"
+#include <cassert>
+
+
+NewObjectListBase::NewObjectListBase(const std::string& className)
+    : _id(-1), _name(className)
+{
+  if (NewObjectListBase::_classes == NULL)
+    NewObjectListBase::_classes = new cList;
+  assert(!NewObjectListBase::exists(className) && "Classes should not be included once, and no two classes should have the same name (key value)");
+
+
+
+}
+
+NewObjectListBase::~NewObjectListBase()
+{
+
+}
+
+int NewObjectListBase::_idCounter = 0;
+NewObjectListBase::cList* NewObjectListBase::_classes = NULL;
+
+
+
+/**
+ * @brief Checks if a Class with name already exists.
+ * @param name The Name of the Class to check.
+ * @return true if such a class already exists.
+ */
+bool NewObjectListBase::exists(const std::string& name)
+{
+  cList::iterator it;
+  for (it = NewObjectListBase::_classes->begin(); it != NewObjectListBase::_classes->end(); it++)
+    if(*it != NULL && (*it)->name() != name)
+      return true;
+  return false;
+}
Index: /trunk/src/lib/lang/new_object_list.h
===================================================================
--- /trunk/src/lib/lang/new_object_list.h	(revision 9662)
+++ /trunk/src/lib/lang/new_object_list.h	(revision 9662)
@@ -0,0 +1,75 @@
+/*!
+ * @file new_object_list.h
+ * @brief Definition of a dynamically allocating ClassID
+ *
+ */
+
+#ifndef _NEW_OBJECT_LIST_H
+#define _NEW_OBJECT_LIST_H
+
+#include "type_info.h"
+#include <set>
+#include <string>
+
+#define DeclareClass(ClassName) \
+   NewObjectList ClassID_##ClassName(ClassName)
+
+#define DeclareInClass(ClassName) \
+   NewObjectList objectList(ClassName)
+
+class NewObjectListBase
+{
+public:
+  int id() const { return _id; };
+  const std::string& name() const { return _name; };
+
+  static int classCount() { return _idCounter; };
+
+  bool compareName(const NewObjectListBase& more) { return this->_name < more.name(); };
+  bool compareID(const NewObjectListBase& more) { return this->_id < more.id(); };
+
+protected:
+  NewObjectListBase(const std::string& className);
+  ~NewObjectListBase();
+private:
+  NewObjectListBase(const NewObjectListBase&);
+
+  static bool exists(const std::string& className);
+
+private:
+  int                           _id;
+  std::string                   _name;
+
+private:
+  typedef std::set<NewObjectListBase*>  cList;
+
+  static int                           _idCounter;      //!< A counter, that gives all classes a Unique ClassID. Access to this Variable is to be Thread-Safe.
+  static cList*                        _classes;        //!< A Set of all the classes in existance.
+};
+
+
+/////////////////////////
+//// TEMPLATISATION /////
+/////////////////////////
+template<class T> class NewObjectList : public NewObjectListBase
+{
+public:
+  NewObjectList(const std::string& name);
+  ~NewObjectList();
+
+private:
+  //! the copy constructor will be hidden.
+  NewObjectList(const NewObjectList& definer) {};
+};
+
+template <class T>
+NewObjectList<T>::NewObjectList(const std::string& name)
+    : NewObjectListBase(name)
+{}
+
+template <class T>
+NewObjectList<T>::~NewObjectList()
+{}
+
+
+#endif /* _NEW_OBJECT_LIST_H */